use std::ffi::{c_char, c_int, c_void};

use crate::lua_State;

pub type luau_AssertHandler = unsafe extern "C" fn(expr: *const c_char, file: *const c_char, line: c_int, function: *const c_char) -> c_int;

pub type luau_Pfunc = unsafe extern "C" fn(L: *mut lua_State, ud: *mut c_void);

extern "C" {
    #[cfg(debug_assertions)]
    #[link_name = "_ZZN4Luau13assertHandlerEvE7handler"]
    pub static mut luau_assertHandler: luau_AssertHandler;

    pub fn luaD_pcall(L: *mut lua_State, func: luau_Pfunc, ud: *mut c_void, old_top: isize, ef: isize);
}
